﻿using DocumentFormat.OpenXml.Bibliography;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PIbd_24_EredavkinRA_BusBusiness.Entities;

public class RoutSheet
{
    public int Id { get; private set; }
    [Browsable(false)]
    public int DriverId { get; private set; }
    [Browsable(false)]
    public int ConductorId { get; private set; }
    [Browsable(false)]
    public int RoutId { get; private set; }
    [DisplayName("Водитель")]
    public string EmployeeNameDriver { get; private set; } = string.Empty;
    [DisplayName("Кондуктор")]
    public string EmployeeNameConductor { get; private set; } = string.Empty;
    [DisplayName("Маршрут")]
    public string RoutName { get; private set; } = string.Empty;
    [DisplayName("Автобусы")]
    public string Bus => RoutSheetBus != null ? string.Join(", ", RoutSheetBus.Select(x => $"{x.BusName}")) : string.Empty;
    [Browsable(false)]
    public IEnumerable<RoutSheetBus> RoutSheetBus { get; private set; } = [];
    [DisplayName("Дата Выезда")]
    public DateTime BusDate { get; private set; }
    public static RoutSheet CreatOpeartion(int id, int driverid, int conductorid, int routid, DateTime busDate, IEnumerable<RoutSheetBus> RoutSheetBus)
    {
        return new RoutSheet
        {
            Id = id,
            DriverId = driverid,
            ConductorId = conductorid,
            RoutId = routid,
            RoutSheetBus = RoutSheetBus,
            BusDate = busDate
        };
    }

    public void SetRoutSheetBus(IEnumerable<RoutSheetBus> routSheetBus)
    {
        if (routSheetBus != null && routSheetBus.Any())
        {
            RoutSheetBus = routSheetBus;
        }
    }


}
